import es, cfglib, keyvalues, usermsg

info = es.AddonInfo()
info['name'] = "Ventrilo"
info['basename'] = "ventrilo"
info['version'] = "1.0"
info['author'] = "Undead"
info['url'] = ""
info['description'] = "Ventrilo Connection Through Server"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

addonpath = es.getAddonPath('ventrilo')
config = cfglib.AddonCFG(addonpath + '/config.cfg')
config.text('**********************\n// ** Ventrilo Options **\n// **********************')
host = config.cvar('vent_hostname','192.168.1.1','Hostname/IP for you Vent')
port = config.cvar('vent_port',"0000",'Vent Port Number')
sname = config.cvar('vent_servername',"Server Name",'Your Vent Server Name Display')
spass = config.cvar('vent_serverpassword',"",'Your Vent Server Password (If Any)')
cname = config.cvar('vent_channelname',"",'Channel Name for your Vent (If Any)')
cpass = config.cvar('vent_channelpassword',"",'Password for your Channel (If Any)')
admins_only = config.cvar('admins_only',1,'1 = Yes, 0 = No - Will allow only admins in admin_list to use the vent_cmd')
admin_list = config.cvar('admin_list',"['STEAMID1','STEAMID2']", 'Insert SteamID\'s For Admins qualified to execute the vent cmd')
mani_support = config.cvar('mani_support',"On",'Use clients.txt from mani for the admin list. Options: On & Off')
vent_cmd = config.cvar('vent_cmd',"!vent",'Command used to connect to the Ventrilo Server')
config.write()

vent_url = 'ventrilo://%s:%s/servername=%s&serverpassword=%s&channelname=%s&channelpassword=%s'%(host,port,sname,spass,cname,cpass)
es.dbgmsg(0, 'Your Ventrilo Connection URL: %s'%vent_url)

def load():
  global admin_list
  config.execute()
  if admins_only == 1:
    if mani_support == "On" or mani_support == "on":
      es.keygroupcreate("clients")
      clients = keyvalues.getKeyGroup("clients")
      clients.load("cfg/mani_admin_plugin/clients.txt")
      admin_list = [x['steam'] for x in clients['players']]
      es.dbgmsg(0, 'Mani Support On. Auto-Detected Admins from Mani Clients.txt')
    elif mani_support == "Off" or mani_support == "off":
      es.dbgmsg(0, 'Mani Support Off. Default admin_list Executed!')
    else:
      es.dbgmsg(0, 'Invalid mani_support value, please check the config.cfg')
      es.unload('ventrilo')
  if not es.exists('saycommand', '%s'%vent_cmd):
    es.regsaycmd('%s'%vent_cmd, 'ventrilo/vent_cmd')
  es.msg('#multi', '#default[#greenVentrilo#default] by #lightgreenUndead #defaulthas been loaded!')

def vent_cmd():
  user = es.getcmduserid()
  if admins_only == 1:
    if es.getplayersteamid(user) not in '%s'%admin_list:
      es.tell(user, '#multi', '#default[#greenVentrilo#default] You must be an admin to use this command!')
    else:
      usermsg.showVGUIPanel(user, 'info', False, {'type':2, 'title':'Ventrilo Connect', 'msg':'%s'%vent_url})
  else:
    usermsg.showVGUIPanel(user, 'info', False, {'type':2, 'title':'Ventrilo Connect', 'msg':vent_url})

def unload():
  if es.exists('saycommand', '%s'%vent_cmd):
    es.unregsaycmd('%s'%vent_cmd)
  es.msg('#multi', '#default[#greenVentrilo#default] by #lightgreenUndead #defaulthas been unloaded!')
